#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <string.h>
#include <dirent.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/resource.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <linux/socket.h>
#include <linux/types.h>
#include <linux/netlink.h>

#define MAX_PAYLOAD			2048
#define MAX_RSTATS			128
#define	OPT_WRITE_INTERVAL	0x01
#define OPT_READ_INTERVAL	0x02
#define OPT_READ_STATS		0x03
#define OPT_READ_RULE		0x04
#define OPT_PROTO_STATS		0x05
#define OPT_RULE_STATS		0x06
#define OPT_READ_ALL_RULES	0x07
#define OPT_STANDARD		0x10
#define OPT_FLUSHTBL		0x11
#define OPT_LAST_IDX		0x20
#define RULE_LEN			80
#define GRAPH_LEN			86400
#define STEP				60
#define	NETLINK_GRAPH		17

struct prot_stat {
	unsigned long count;
	unsigned long byte;
};

struct proto_stat {
	struct prot_stat drop;
	struct prot_stat accept;
	struct prot_stat stolen;
	struct prot_stat queue;
	struct prot_stat repeat;
};


struct total_stats {
	struct proto_stat ip;
	struct proto_stat icmp;
	struct proto_stat igmp;
	struct proto_stat ipip;
	struct proto_stat tcp;
	struct proto_stat udp;
	struct proto_stat ipv6;
	struct proto_stat raw;
}; 

struct rule_stat {
	char *key;
	char *rule_desc;
	struct prot_stat ps;
};

struct sockaddr_nl src_addr, dest_addr;
struct nlmsghdr *nlh = NULL;
struct iovec iov;
struct msghdr msg;
int sock_fd;
struct rule_stat rule_stats[MAX_RSTATS];
char *hostname;
char *destdir;
int last_rstats_idx;
int verbose;
int debug;

#define DROP_COUNT(x)	t->x.drop.count	
#define DROP_BYTE(x)	t->x.drop.byte
#define ACCEPT_COUNT(x)	t->x.accept.count	
#define ACCEPT_BYTE(x)	t->x.accept.byte


char *version = "0.2";
